/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////


#ifndef ACAD_DARK_PALETTE

// Acad's palette for dark background and for conversion to R15 (lookup color index )
#define ACAD_DARK_PALETTE \
\
  ODPALENTRY(0, 0, 0) \
  ODPALENTRY(255, 0, 0) \
  ODPALENTRY(255, 255, 0) \
  ODPALENTRY(0, 255, 0) \
  ODPALENTRY(0, 255, 255) \
  ODPALENTRY(0, 0, 255) \
  ODPALENTRY(255, 0, 255) \
  ODPALENTRY(255, 255, 255) \
  ODPALENTRY(128, 128, 128) \
  ODPALENTRY(192, 192, 192) \
  ODPALENTRY(255, 0, 0) \
  ODPALENTRY(255, 127, 127) \
  ODPALENTRY(204, 0, 0) \
  ODPALENTRY(204, 102, 102) \
  ODPALENTRY(153, 0, 0) \
  ODPALENTRY(153, 76, 76) \
  ODPALENTRY(127, 0, 0) \
  ODPALENTRY(127, 63, 63) \
  ODPALENTRY(76, 0, 0) \
  ODPALENTRY(76, 38, 38) \
  ODPALENTRY(255, 63, 0) \
  ODPALENTRY(255, 159, 127) \
  ODPALENTRY(204, 51, 0) \
  ODPALENTRY(204, 127, 102) \
  ODPALENTRY(153, 38, 0) \
  ODPALENTRY(153, 95, 76) \
  ODPALENTRY(127, 31, 0) \
  ODPALENTRY(127, 79, 63) \
  ODPALENTRY(76, 19, 0) \
  ODPALENTRY(76, 47, 38) \
  ODPALENTRY(255, 127, 0) \
  ODPALENTRY(255, 191, 127) \
  ODPALENTRY(204, 102, 0) \
  ODPALENTRY(204, 153, 102) \
  ODPALENTRY(153, 76, 0) \
  ODPALENTRY(153, 114, 76) \
  ODPALENTRY(127, 63, 0) \
  ODPALENTRY(127, 95, 63) \
  ODPALENTRY(76, 38, 0) \
  ODPALENTRY(76, 57, 38) \
  ODPALENTRY(255, 191, 0) \
  ODPALENTRY(255, 223, 127) \
  ODPALENTRY(204, 153, 0) \
  ODPALENTRY(204, 178, 102) \
  ODPALENTRY(153, 114, 0) \
  ODPALENTRY(153, 133, 76) \
  ODPALENTRY(127, 95, 0) \
  ODPALENTRY(127, 111, 63) \
  ODPALENTRY(76, 57, 0) \
  ODPALENTRY(76, 66, 38) \
  ODPALENTRY(255, 255, 0) \
  ODPALENTRY(255, 255, 127) \
  ODPALENTRY(204, 204, 0) \
  ODPALENTRY(204, 204, 102) \
  ODPALENTRY(153, 153, 0) \
  ODPALENTRY(153, 153, 76) \
  ODPALENTRY(127, 127, 0) \
  ODPALENTRY(127, 127, 63) \
  ODPALENTRY(76, 76, 0) \
  ODPALENTRY(76, 76, 38) \
  ODPALENTRY(191, 255, 0) \
  ODPALENTRY(223, 255, 127) \
  ODPALENTRY(153, 204, 0) \
  ODPALENTRY(178, 204, 102) \
  ODPALENTRY(114, 153, 0) \
  ODPALENTRY(133, 153, 76) \
  ODPALENTRY(95, 127, 0) \
  ODPALENTRY(111, 127, 63) \
  ODPALENTRY(57, 76, 0) \
  ODPALENTRY(66, 76, 38) \
  ODPALENTRY(127, 255, 0) \
  ODPALENTRY(191, 255, 127) \
  ODPALENTRY(102, 204, 0) \
  ODPALENTRY(153, 204, 102) \
  ODPALENTRY(76, 153, 0) \
  ODPALENTRY(114, 153, 76) \
  ODPALENTRY(63, 127, 0) \
  ODPALENTRY(95, 127, 63) \
  ODPALENTRY(38, 76, 0) \
  ODPALENTRY(57, 76, 38) \
  ODPALENTRY(63, 255, 0) \
  ODPALENTRY(159, 255, 127) \
  ODPALENTRY(51, 204, 0) \
  ODPALENTRY(127, 204, 102) \
  ODPALENTRY(38, 153, 0) \
  ODPALENTRY(95, 153, 76) \
  ODPALENTRY(31, 127, 0) \
  ODPALENTRY(79, 127, 63) \
  ODPALENTRY(19, 76, 0) \
  ODPALENTRY(47, 76, 38) \
  ODPALENTRY(0, 255, 0) \
  ODPALENTRY(127, 255, 127) \
  ODPALENTRY(0, 204, 0) \
  ODPALENTRY(102, 204, 102) \
  ODPALENTRY(0, 153, 0) \
  ODPALENTRY(76, 153, 76) \
  ODPALENTRY(0, 127, 0) \
  ODPALENTRY(63, 127, 63) \
  ODPALENTRY(0, 76, 0) \
  ODPALENTRY(38, 76, 38) \
  ODPALENTRY(0, 255, 63) \
  ODPALENTRY(127, 255, 159) \
  ODPALENTRY(0, 204, 51) \
  ODPALENTRY(102, 204, 127) \
  ODPALENTRY(0, 153, 38) \
  ODPALENTRY(76, 153, 95) \
  ODPALENTRY(0, 127, 31) \
  ODPALENTRY(63, 127, 79) \
  ODPALENTRY(0, 76, 19) \
  ODPALENTRY(38, 76, 47) \
  ODPALENTRY(0, 255, 127) \
  ODPALENTRY(127, 255, 191) \
  ODPALENTRY(0, 204, 102) \
  ODPALENTRY(102, 204, 153) \
  ODPALENTRY(0, 153, 76) \
  ODPALENTRY(76, 153, 114) \
  ODPALENTRY(0, 127, 63) \
  ODPALENTRY(63, 127, 95) \
  ODPALENTRY(0, 76, 38) \
  ODPALENTRY(38, 76, 57) \
  ODPALENTRY(0, 255, 191) \
  ODPALENTRY(127, 255, 223) \
  ODPALENTRY(0, 204, 153) \
  ODPALENTRY(102, 204, 178) \
  ODPALENTRY(0, 153, 114) \
  ODPALENTRY(76, 153, 133) \
  ODPALENTRY(0, 127, 95) \
  ODPALENTRY(63, 127, 111) \
  ODPALENTRY(0, 76, 57) \
  ODPALENTRY(38, 76, 66) \
  ODPALENTRY(0, 255, 255) \
  ODPALENTRY(127, 255, 255) \
  ODPALENTRY(0, 204, 204) \
  ODPALENTRY(102, 204, 204) \
  ODPALENTRY(0, 153, 153) \
  ODPALENTRY(76, 153, 153) \
  ODPALENTRY(0, 127, 127) \
  ODPALENTRY(63, 127, 127) \
  ODPALENTRY(0, 76, 76) \
  ODPALENTRY(38, 76, 76) \
  ODPALENTRY(0, 191, 255) \
  ODPALENTRY(127, 223, 255) \
  ODPALENTRY(0, 153, 204) \
  ODPALENTRY(102, 178, 204) \
  ODPALENTRY(0, 114, 153) \
  ODPALENTRY(76, 133, 153) \
  ODPALENTRY(0, 95, 127) \
  ODPALENTRY(63, 111, 127) \
  ODPALENTRY(0, 57, 76) \
  ODPALENTRY(38, 66, 76) \
  ODPALENTRY(0, 127, 255) \
  ODPALENTRY(127, 191, 255) \
  ODPALENTRY(0, 102, 204) \
  ODPALENTRY(102, 153, 204) \
  ODPALENTRY(0, 76, 153) \
  ODPALENTRY(76, 114, 153) \
  ODPALENTRY(0, 63, 127) \
  ODPALENTRY(63, 95, 127) \
  ODPALENTRY(0, 38, 76) \
  ODPALENTRY(38, 57, 76) \
  ODPALENTRY(0, 63, 255) \
  ODPALENTRY(127, 159, 255) \
  ODPALENTRY(0, 51, 204) \
  ODPALENTRY(102, 127, 204) \
  ODPALENTRY(0, 38, 153) \
  ODPALENTRY(76, 95, 153) \
  ODPALENTRY(0, 31, 127) \
  ODPALENTRY(63, 79, 127) \
  ODPALENTRY(0, 19, 76) \
  ODPALENTRY(38, 47, 76) \
  ODPALENTRY(0, 0, 255) \
  ODPALENTRY(127, 127, 255) \
  ODPALENTRY(0, 0, 204) \
  ODPALENTRY(102, 102, 204) \
  ODPALENTRY(0, 0, 153) \
  ODPALENTRY(76, 76, 153) \
  ODPALENTRY(0, 0, 127) \
  ODPALENTRY(63, 63, 127) \
  ODPALENTRY(0, 0, 76) \
  ODPALENTRY(38, 38, 76) \
  ODPALENTRY(63, 0, 255) \
  ODPALENTRY(159, 127, 255) \
  ODPALENTRY(51, 0, 204) \
  ODPALENTRY(127, 102, 204) \
  ODPALENTRY(38, 0, 153) \
  ODPALENTRY(95, 76, 153) \
  ODPALENTRY(31, 0, 127) \
  ODPALENTRY(79, 63, 127) \
  ODPALENTRY(19, 0, 76) \
  ODPALENTRY(47, 38, 76) \
  ODPALENTRY(127, 0, 255) \
  ODPALENTRY(191, 127, 255) \
  ODPALENTRY(102, 0, 204) \
  ODPALENTRY(153, 102, 204) \
  ODPALENTRY(76, 0, 153) \
  ODPALENTRY(114, 76, 153) \
  ODPALENTRY(63, 0, 127) \
  ODPALENTRY(95, 63, 127) \
  ODPALENTRY(38, 0, 76) \
  ODPALENTRY(57, 38, 76) \
  ODPALENTRY(191, 0, 255) \
  ODPALENTRY(223, 127, 255) \
  ODPALENTRY(153, 0, 204) \
  ODPALENTRY(178, 102, 204) \
  ODPALENTRY(114, 0, 153) \
  ODPALENTRY(133, 76, 153) \
  ODPALENTRY(95, 0, 127) \
  ODPALENTRY(111, 63, 127) \
  ODPALENTRY(57, 0, 76) \
  ODPALENTRY(66, 38, 76) \
  ODPALENTRY(255, 0, 255) \
  ODPALENTRY(255, 127, 255) \
  ODPALENTRY(204, 0, 204) \
  ODPALENTRY(204, 102, 204) \
  ODPALENTRY(153, 0, 153) \
  ODPALENTRY(153, 76, 153) \
  ODPALENTRY(127, 0, 127) \
  ODPALENTRY(127, 63, 127) \
  ODPALENTRY(76, 0, 76) \
  ODPALENTRY(76, 38, 76) \
  ODPALENTRY(255, 0, 191) \
  ODPALENTRY(255, 127, 223) \
  ODPALENTRY(204, 0, 153) \
  ODPALENTRY(204, 102, 178) \
  ODPALENTRY(153, 0, 114) \
  ODPALENTRY(153, 76, 133) \
  ODPALENTRY(127, 0, 95) \
  ODPALENTRY(127, 63, 111) \
  ODPALENTRY(76, 0, 57) \
  ODPALENTRY(76, 38, 66) \
  ODPALENTRY(255, 0, 127) \
  ODPALENTRY(255, 127, 191) \
  ODPALENTRY(204, 0, 102) \
  ODPALENTRY(204, 102, 153) \
  ODPALENTRY(153, 0, 76) \
  ODPALENTRY(153, 76, 114) \
  ODPALENTRY(127, 0, 63) \
  ODPALENTRY(127, 63, 95) \
  ODPALENTRY(76, 0, 38) \
  ODPALENTRY(76, 38, 57) \
  ODPALENTRY(255, 0, 63) \
  ODPALENTRY(255, 127, 159) \
  ODPALENTRY(204, 0, 51) \
  ODPALENTRY(204, 102, 127) \
  ODPALENTRY(153, 0, 38) \
  ODPALENTRY(153, 76, 95) \
  ODPALENTRY(127, 0, 31) \
  ODPALENTRY(127, 63, 79) \
  ODPALENTRY(76, 0, 19) \
  ODPALENTRY(76, 38, 47) \
  ODPALENTRY(51, 51, 51) \
  ODPALENTRY(91, 91, 91) \
  ODPALENTRY(132, 132, 132) \
  ODPALENTRY(173, 173, 173) \
  ODPALENTRY(214, 214, 214) \
  ODPALENTRY(255, 255, 255)

// Acad's palette for light background
#define ACAD_LIGHT_PALETTE \
\
  ODPALENTRY(255, 255, 255) \
  ODPALENTRY(255, 0, 0) \
  ODPALENTRY(255, 255, 0) \
  ODPALENTRY(0, 255, 0) \
  ODPALENTRY(0, 255, 255) \
  ODPALENTRY(0, 0, 255) \
  ODPALENTRY(255, 0, 255) \
  ODPALENTRY(0, 0, 0) \
  ODPALENTRY(128, 128, 128) \
  ODPALENTRY(192, 192, 192) \
  ODPALENTRY(255, 0, 0) \
  ODPALENTRY(255, 127, 127) \
  ODPALENTRY(165, 0, 0) \
  ODPALENTRY(165, 82, 82) \
  ODPALENTRY(127, 0, 0) \
  ODPALENTRY(127, 63, 63) \
  ODPALENTRY(76, 0, 0) \
  ODPALENTRY(76, 38, 38) \
  ODPALENTRY(38, 0, 0) \
  ODPALENTRY(38, 19, 19) \
  ODPALENTRY(255, 63, 0) \
  ODPALENTRY(255, 159, 127) \
  ODPALENTRY(165, 41, 0) \
  ODPALENTRY(165, 103, 82) \
  ODPALENTRY(127, 31, 0) \
  ODPALENTRY(127, 79, 63) \
  ODPALENTRY(76, 19, 0) \
  ODPALENTRY(76, 47, 38) \
  ODPALENTRY(38, 9, 0) \
  ODPALENTRY(38, 23, 19) \
  ODPALENTRY(255, 127, 0) \
  ODPALENTRY(255, 191, 127) \
  ODPALENTRY(165, 82, 0) \
  ODPALENTRY(165, 124, 82) \
  ODPALENTRY(127, 63, 0) \
  ODPALENTRY(127, 95, 63) \
  ODPALENTRY(76, 38, 0) \
  ODPALENTRY(76, 57, 38) \
  ODPALENTRY(38, 19, 0) \
  ODPALENTRY(38, 28, 19) \
  ODPALENTRY(255, 191, 0) \
  ODPALENTRY(255, 223, 127) \
  ODPALENTRY(165, 124, 0) \
  ODPALENTRY(165, 145, 82) \
  ODPALENTRY(127, 95, 0) \
  ODPALENTRY(127, 111, 63) \
  ODPALENTRY(76, 57, 0) \
  ODPALENTRY(76, 66, 38) \
  ODPALENTRY(38, 28, 0) \
  ODPALENTRY(38, 33, 19) \
  ODPALENTRY(255, 255, 0) \
  ODPALENTRY(255, 255, 127) \
  ODPALENTRY(165, 165, 0) \
  ODPALENTRY(165, 165, 82) \
  ODPALENTRY(127, 127, 0) \
  ODPALENTRY(127, 127, 63) \
  ODPALENTRY(76, 76, 0) \
  ODPALENTRY(76, 76, 38) \
  ODPALENTRY(38, 38, 0) \
  ODPALENTRY(38, 38, 19) \
  ODPALENTRY(191, 255, 0) \
  ODPALENTRY(223, 255, 127) \
  ODPALENTRY(124, 165, 0) \
  ODPALENTRY(145, 165, 82) \
  ODPALENTRY(95, 127, 0) \
  ODPALENTRY(111, 127, 63) \
  ODPALENTRY(57, 76, 0) \
  ODPALENTRY(66, 76, 38) \
  ODPALENTRY(28, 38, 0) \
  ODPALENTRY(33, 38, 19) \
  ODPALENTRY(127, 255, 0) \
  ODPALENTRY(191, 255, 127) \
  ODPALENTRY(82, 165, 0) \
  ODPALENTRY(124, 165, 82) \
  ODPALENTRY(63, 127, 0) \
  ODPALENTRY(95, 127, 63) \
  ODPALENTRY(38, 76, 0) \
  ODPALENTRY(57, 76, 38) \
  ODPALENTRY(19, 38, 0) \
  ODPALENTRY(28, 38, 19) \
  ODPALENTRY(63, 255, 0) \
  ODPALENTRY(159, 255, 127) \
  ODPALENTRY(41, 165, 0) \
  ODPALENTRY(103, 165, 82) \
  ODPALENTRY(31, 127, 0) \
  ODPALENTRY(79, 127, 63) \
  ODPALENTRY(19, 76, 0) \
  ODPALENTRY(47, 76, 38) \
  ODPALENTRY(9, 38, 0) \
  ODPALENTRY(23, 38, 19) \
  ODPALENTRY(0, 255, 0) \
  ODPALENTRY(127, 255, 127) \
  ODPALENTRY(0, 165, 0) \
  ODPALENTRY(82, 165, 82) \
  ODPALENTRY(0, 127, 0) \
  ODPALENTRY(63, 127, 63) \
  ODPALENTRY(0, 76, 0) \
  ODPALENTRY(38, 76, 38) \
  ODPALENTRY(0, 38, 0) \
  ODPALENTRY(19, 38, 19) \
  ODPALENTRY(0, 255, 63) \
  ODPALENTRY(127, 255, 159) \
  ODPALENTRY(0, 165, 41) \
  ODPALENTRY(82, 165, 103) \
  ODPALENTRY(0, 127, 31) \
  ODPALENTRY(63, 127, 79) \
  ODPALENTRY(0, 76, 19) \
  ODPALENTRY(38, 76, 47) \
  ODPALENTRY(0, 38, 9) \
  ODPALENTRY(19, 38, 23) \
  ODPALENTRY(0, 255, 127) \
  ODPALENTRY(127, 255, 191) \
  ODPALENTRY(0, 165, 82) \
  ODPALENTRY(82, 165, 124) \
  ODPALENTRY(0, 127, 63) \
  ODPALENTRY(63, 127, 95) \
  ODPALENTRY(0, 76, 38) \
  ODPALENTRY(38, 76, 57) \
  ODPALENTRY(0, 38, 19) \
  ODPALENTRY(19, 38, 28) \
  ODPALENTRY(0, 255, 191) \
  ODPALENTRY(127, 255, 223) \
  ODPALENTRY(0, 165, 124) \
  ODPALENTRY(82, 165, 145) \
  ODPALENTRY(0, 127, 95) \
  ODPALENTRY(63, 127, 111) \
  ODPALENTRY(0, 76, 57) \
  ODPALENTRY(38, 76, 66) \
  ODPALENTRY(0, 38, 28) \
  ODPALENTRY(19, 38, 33) \
  ODPALENTRY(0, 255, 255) \
  ODPALENTRY(127, 255, 255) \
  ODPALENTRY(0, 165, 165) \
  ODPALENTRY(82, 165, 165) \
  ODPALENTRY(0, 127, 127) \
  ODPALENTRY(63, 127, 127) \
  ODPALENTRY(0, 76, 76) \
  ODPALENTRY(38, 76, 76) \
  ODPALENTRY(0, 38, 38) \
  ODPALENTRY(19, 38, 38) \
  ODPALENTRY(0, 191, 255) \
  ODPALENTRY(127, 223, 255) \
  ODPALENTRY(0, 124, 165) \
  ODPALENTRY(82, 145, 165) \
  ODPALENTRY(0, 95, 127) \
  ODPALENTRY(63, 111, 127) \
  ODPALENTRY(0, 57, 76) \
  ODPALENTRY(38, 66, 76) \
  ODPALENTRY(0, 28, 38) \
  ODPALENTRY(19, 33, 38) \
  ODPALENTRY(0, 127, 255) \
  ODPALENTRY(127, 191, 255) \
  ODPALENTRY(0, 82, 165) \
  ODPALENTRY(82, 124, 165) \
  ODPALENTRY(0, 63, 127) \
  ODPALENTRY(63, 95, 127) \
  ODPALENTRY(0, 38, 76) \
  ODPALENTRY(38, 57, 76) \
  ODPALENTRY(0, 19, 38) \
  ODPALENTRY(19, 28, 38) \
  ODPALENTRY(0, 63, 255) \
  ODPALENTRY(127, 159, 255) \
  ODPALENTRY(0, 41, 165) \
  ODPALENTRY(82, 103, 165) \
  ODPALENTRY(0, 31, 127) \
  ODPALENTRY(63, 79, 127) \
  ODPALENTRY(0, 19, 76) \
  ODPALENTRY(38, 47, 76) \
  ODPALENTRY(0, 9, 38) \
  ODPALENTRY(19, 23, 38) \
  ODPALENTRY(0, 0, 255) \
  ODPALENTRY(127, 127, 255) \
  ODPALENTRY(0, 0, 165) \
  ODPALENTRY(82, 82, 165) \
  ODPALENTRY(0, 0, 127) \
  ODPALENTRY(63, 63, 127) \
  ODPALENTRY(0, 0, 76) \
  ODPALENTRY(38, 38, 76) \
  ODPALENTRY(0, 0, 38) \
  ODPALENTRY(19, 19, 38) \
  ODPALENTRY(63, 0, 255) \
  ODPALENTRY(159, 127, 255) \
  ODPALENTRY(41, 0, 165) \
  ODPALENTRY(103, 82, 165) \
  ODPALENTRY(31, 0, 127) \
  ODPALENTRY(79, 63, 127) \
  ODPALENTRY(19, 0, 76) \
  ODPALENTRY(47, 38, 76) \
  ODPALENTRY(9, 0, 38) \
  ODPALENTRY(23, 19, 38) \
  ODPALENTRY(127, 0, 255) \
  ODPALENTRY(191, 127, 255) \
  ODPALENTRY(82, 0, 165) \
  ODPALENTRY(124, 82, 165) \
  ODPALENTRY(63, 0, 127) \
  ODPALENTRY(95, 63, 127) \
  ODPALENTRY(38, 0, 76) \
  ODPALENTRY(57, 38, 76) \
  ODPALENTRY(19, 0, 38) \
  ODPALENTRY(28, 19, 38) \
  ODPALENTRY(191, 0, 255) \
  ODPALENTRY(223, 127, 255) \
  ODPALENTRY(124, 0, 165) \
  ODPALENTRY(145, 82, 165) \
  ODPALENTRY(95, 0, 127) \
  ODPALENTRY(111, 63, 127) \
  ODPALENTRY(57, 0, 76) \
  ODPALENTRY(66, 38, 76) \
  ODPALENTRY(28, 0, 38) \
  ODPALENTRY(33, 19, 38) \
  ODPALENTRY(255, 0, 255) \
  ODPALENTRY(255, 127, 255) \
  ODPALENTRY(165, 0, 165) \
  ODPALENTRY(165, 82, 165) \
  ODPALENTRY(127, 0, 127) \
  ODPALENTRY(127, 63, 127) \
  ODPALENTRY(76, 0, 76) \
  ODPALENTRY(76, 38, 76) \
  ODPALENTRY(38, 0, 38) \
  ODPALENTRY(38, 19, 38) \
  ODPALENTRY(255, 0, 191) \
  ODPALENTRY(255, 127, 223) \
  ODPALENTRY(165, 0, 124) \
  ODPALENTRY(165, 82, 145) \
  ODPALENTRY(127, 0, 95) \
  ODPALENTRY(127, 63, 111) \
  ODPALENTRY(76, 0, 57) \
  ODPALENTRY(76, 38, 66) \
  ODPALENTRY(38, 0, 28) \
  ODPALENTRY(38, 19, 33) \
  ODPALENTRY(255, 0, 127) \
  ODPALENTRY(255, 127, 191) \
  ODPALENTRY(165, 0, 82) \
  ODPALENTRY(165, 82, 124) \
  ODPALENTRY(127, 0, 63) \
  ODPALENTRY(127, 63, 95) \
  ODPALENTRY(76, 0, 38) \
  ODPALENTRY(76, 38, 57) \
  ODPALENTRY(38, 0, 19) \
  ODPALENTRY(38, 19, 28) \
  ODPALENTRY(255, 0, 63) \
  ODPALENTRY(255, 127, 159) \
  ODPALENTRY(165, 0, 41) \
  ODPALENTRY(165, 82, 103) \
  ODPALENTRY(127, 0, 31) \
  ODPALENTRY(127, 63, 79) \
  ODPALENTRY(76, 0, 19) \
  ODPALENTRY(76, 38, 47) \
  ODPALENTRY(38, 0, 9) \
  ODPALENTRY(38, 19, 23) \
  ODPALENTRY(0, 0, 0) \
  ODPALENTRY(45, 45, 45) \
  ODPALENTRY(91, 91, 91) \
  ODPALENTRY(137, 137, 137) \
  ODPALENTRY(183, 183, 183) \
  ODPALENTRY(179, 179, 179)

#endif //#ifndef ACAD_DARK_PALETTE
