/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2002-2016, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) Copyright (C) 2002-2016 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
///////////////////////////////////////////////////////////////////////////////

#ifndef _ODDBCONSTRAINTSINTERFACEPE_INCLUDED_
#define _ODDBCONSTRAINTSINTERFACEPE_INCLUDED_ /*!DOM*/

#include "DbExport.h"
#include "DbObject.h"

// this is temporary internal interface between dynamic blocks and constraints
/*!DOM*/
struct TOOLKIT_EXPORT OdDbConstraintsInterfacePE : OdRxObject
{
  ODRX_DECLARE_MEMBERS(OdDbConstraintsInterfacePE);
  virtual OdResult getAssocVariableName(const OdDbObject* pObject, OdString& name);
  virtual OdResult getAssocVariableValue(const OdDbObject* pObject, OdDbObjectId blockId, OdResBufPtr& value);
  virtual OdResult setAssocVariableValue(const OdDbObject* pObject, OdDbObjectId blockId, const OdResBuf* value);
};

/*!DOM*/
typedef OdSmartPtr<OdDbConstraintsInterfacePE> OdDbConstraintsInterfacePEPtr;

#endif // _ODDBCONSTRAINTSINTERFACEPE_INCLUDED_
