/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////




#ifndef _ENTITIES_INCLUDED_
#define _ENTITIES_INCLUDED_

#include "Ge/GeScale3d.h"
#include "Ge/GePoint2d.h"
#include "Ge/GePoint2dArray.h"
#include "Ge/GeDoubleArray.h"
#include "Ge/GeMatrix3d.h"
#include "Ge/GeCircArc3d.h"

#include "DbArc.h"
#include "DbAttributeDefinition.h"
#include "DbAttribute.h"
#include "DbBlockBegin.h"
#include "DbModelerGeometry.h"
#include "DbCircle.h"
#include "DbDimension.h"
#include "DbAlignedDimension.h"
#include "DbEllipse.h"
#include "DbBlockEnd.h"
#include "DbFace.h"
#include "DbBlockReference.h"
#include "DbMInsertBlock.h"
#include "DbLeader.h"
#include "DbMLeader.h"
#include "DbLine.h"
#include "DbMline.h"
#include "DbMText.h"
#include "DbPoint.h"
#include "Db2dPolyline.h"
#include "DbRay.h"
#include "DbSequenceEnd.h"
#include "DbShape.h"
#include "DbSpline.h"
#include "DbText.h"
#include "DbFcf.h"
#include "DbVertex.h"
#include "Db2dVertex.h"
#include "Db3dPolylineVertex.h"
#include "DbPolygonMeshVertex.h"
#include "DbPolyFaceMeshVertex.h"
#include "DbFaceRecord.h"
#include "DbViewport.h"
#include "DbXline.h"
#include "DbHatch.h"
#include "DbPolyline.h"
#include "DbOle2Frame.h"
#include "DbProxyEntity.h"
#include "Db3dPolyline.h"
#include "DbOrdinateDimension.h"
#include "DbRotatedDimension.h"
#include "Db3PointAngularDimension.h"
#include "Db2LineAngularDimension.h"
#include "DbRadialDimension.h"
#include "DbDiametricDimension.h"
#include "DbPolyFaceMesh.h"
#include "DbPolygonMesh.h"
#include "DbSolid.h"
#include "DbTrace.h"
#include "DbRegion.h"
#include "Db3dSolid.h"
#include "DbBody.h"
#include "DbXrecord.h"

#include "DbArcAlignedText.h"
#include "DbRasterImage.h"
#include "RText.h"
#include "DbWipeout.h"
#include "DbTable.h"
#include "Tables.h"
#include "DbDictionary.h"
#include "DbLight.h"
#include "DbUnderlayReference.h"
#include "DbSection.h"

#endif // _ENTITIES_INCLUDED_
