/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2002-2021, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Open Design Alliance software pursuant to a license 
//   agreement with Open Design Alliance.
//   Open Design Alliance Copyright (C) 2002-2021 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
///////////////////////////////////////////////////////////////////////////////

#ifndef OD_MLEADERBREAKS_H
#define OD_MLEADERBREAKS_H

#include "DbMLeader.h"
#include "Ge/GePoint3dArray.h"
#include "TD_PackPush.h"

/** \details
<group !!RECORDS_tdrawings_apiref>
*/
struct TOOLKIT_EXPORT OdDbMLeaderBreaks
{
  struct BreakInfo
  {
    OdInt32 m_nSegment;
    OdGePoint3dArray m_StartPoints;
    OdGePoint3dArray m_EndPoints;
  };
  static OdResult getBreaks(const OdDbMLeader* pMleader, int leaderLineIndex, OdArray<BreakInfo>& breaks);
  static OdResult setBreaks(OdDbMLeader* pMleader, int leaderLineIndex, const OdArray<BreakInfo>& breaks);
  static OdResult getDoglegBreaks(const OdDbMLeader* pMleader, int leaderRootIndex, OdGePoint3dArray& startPoints, OdGePoint3dArray& endPoints);
  static OdResult setDoglegBreaks(OdDbMLeader* pMleader, int leaderRootIndex, const OdGePoint3dArray& startPoints, const OdGePoint3dArray& endPoints);
};

#include "TD_PackPop.h"
#endif
