/*****************************************************************************
***     ļ: GcPlot.h
*****************************************************************************/

#ifndef __GCAD__GS_PLOT__INTERFACE__H__
#define __GCAD__GS_PLOT__INTERFACE__H__

#include "../GcGraphicSystemService.h"
#include "GcPlotDataDumpper.h"


class GcGePoint2d;
class GcDbObject;
class GcDbObjectId;
class GcApDocument;

struct GcPlotParameters
{
  /* ӡռ
   0: ǰtilemodeָ Model_Space or Paper_Space
   1: ģ Model_Space
   2: ͼֽ Paper_Space
   3:  Model_Space, Paper_Space, Paper_Space0, Paper_Space1, ...
  */
  int  pltSpace; // Ĭֵ: 0(ǰtilemodeָ)
  GcDbObjectId blkSpaceId;  //  pltSpace=3 ʱЧ

  /* ӡ
   0: "ʾ"ǰͼĿɼΧͼɼΧĲӡܲü
   1: """"ԵǰͼģͿռΪ""ͼֽռΪ""
      ""ͼֽռ趨ĴӡͼֽСͼֽĲӡܲü
      ""ģͿռ趨LIMMIN,LIMMAXϵͳָ÷ΧĲӡܲü
   2: ""ǰͼָĴڷΧ÷ΧĲӡܲü
   3: "Χ"ԵǰͼǰռʵͼηΧ޲ü
   4: "ͼ"ָͼĿɼΧӦͼͼɼΧĲӡܲü
  */
  int  pltArea;  // Ĭֵ: 0("ʾ")
  GcGePoint2d lower_left, upper_right; // DCS pltArea=2 ʱЧ
  GcDbObjectId pltViewId; //  pltArea=4 ʱЧ

  GcGePoint2d pltRealArea;	//ӡȣأ

  /* ӡĵ
   plotCenter: ֵãⲿãֵ
     pltArea=0: ǰͼĵ
     pltArea=1: ͼν޵ĵ  ֿռ´ӡͼֽĵ
     pltArea=2: ָڵĵ
     pltArea=3: ͼηΧĵ
     pltArea=4: ǰͼ(pltViewId)ĵ
     viewCenter!=NULL: viewCenter
   viewCenter: ΪNULLʾԶĵ
  */
  GcGePoint2d plotCenter;
  const GcGePoint2d* pltViewCenter; // Ĭֵ: NULL

  /* ӡģʽ
   0: ĬϣʹôӡͼĻģʽ
   1: ׼߿ (Wireframe)
   2: , Hidden Lines Removed
   3: ɫ, Shaded
   4: Ӿʽ, Visual Style
  */
  int  pltViewMode; // Ĭֵ: 0

  /* ӡ˳
   0: ĬϣʹõǰռĻ˳
   1: 棬ʹʵĴ˳
   2: ͼֽ, Ի˳дӡͼֽռڵʵ
  */
  bool pltOrder;  // Ĭֵ: 0

  /* ӡʵ壨ã
   0: ʵ
   1: ָ GcDbObjectId 
   2: ָ GcDbObject 
   3: ָѡ
   x: չ޶ӡĳʵ壬ȵ
  */
  int  pltEntities; // Ĭֵ: 0(all entities)
  struct _PlotIds
  {
    OdInt32 num;
    const GcDbObjectId* ids;
  } plotIds;   //  pltEntities=1 ʱЧ
  struct _PlotObjs
  {
    OdInt32 num;
    const GcDbObject** objs;
  } plotObjs;  //  pltEntities=2 ʱЧ
  //GcEdSelectionSet* ss; //???

  /* 
  */
  GcDbObjectId vstyleId; // ӾʽIDpltViewMode==4

  GcString     pltStyleFilePath;

  bool pltLineweights;
  bool pltPlotStyles;
  double pltScaleLineweights;

  GcPlotParameters()
  {
    pltSpace = 0;
    pltArea = 0;
    pltViewCenter = NULL;
    pltViewMode = 0;
    pltOrder = 0;
    pltEntities = 0;
    plotIds.num = 0;
    plotIds.ids = NULL;
    plotObjs.num = 0;
    plotObjs.objs = NULL;
    pltLineweights = true;
    pltPlotStyles = true;
    pltScaleLineweights = 1.0;
  }
};

class GcPlotInterface
{
public:
  virtual OdInt32 genPlotData(GcDbObjectId blockTableRecordId, // NULL => curDocument()
    GcPlotDataDumpper* pDumpper,
    GcPlotParameters* pParams,
    GcPlotProgressMeter* pProgress = NULL) = 0;
  virtual void clearPlotData() = 0;
};

inline GcPlotInterface* gcgsPlotInterface()
{
  GcadGraphicSystemService* pGsSrv = gcadGraphicSysService();
  return pGsSrv ? pGsSrv->plotInterface() : NULL;
}


#endif //__GCAD__GS_PLOT__INTERFACE__H__

