#ifndef _UI_REACTOR_H_
#define _UI_REACTOR_H_

#include "..\OdMutex.h"
#include "..\RxEvent.h"
//#include <map>

//طӦ  ܣ˷Ӧ

class CGcadUiReactor : public GcRxObject
{
public:
  /*
    ʽлʱķӦӿthemeStyleChanged
    @nThemeIndex ʽ
  */
  virtual ~CGcadUiReactor() {}
  virtual void themeStyleChanged(HcInt32 nThemeIndex) = 0;

};


typedef OdSmartPtr<CGcadUiReactor> GcRxGcadUiReactorPtr;

#define DEFINE_UIEVENT(method, params)\
virtual void fire##method params

/*
  UI Ӧʹ
  Ӧӣ Ƴ
*/
enum em_UITYPE
{
  em_Gcad = 0,
  em_Cmd,
  em_Layman,
  em_sheetSet,
  em_gmodeler,
};

typedef std::map<em_UITYPE, HINSTANCE> MAPUI2ICONSRC;
typedef std::map<HcInt32, MAPUI2ICONSRC> MAPTHEME2UISRC;


class CGcadUiEvent : public GcRxObject
{
public:
  CGcadUiEvent() {}
  virtual ~CGcadUiEvent() {}
  /*
    getCurThemeIndex ȡǰ
    ֵ:  50000+
  */
  virtual HcInt32 getCurThemeIndex() = 0;
  /*
    getIconSrc ȡǰԴ
    ֵ: Դ
  */
  virtual HINSTANCE getIconSrcInstance(const em_UITYPE& emType) = 0;

public:
  /*
    addReactor ӷӦ
    @pReactor ҪӵбķӦ
  */
  virtual void addReactor(CGcadUiReactor* pReactor) = 0;
  /*
    removeReactor ƳӦ
    @pReactor ҪбƳķӦ
  */
  virtual void removeReactor(CGcadUiReactor* pReactor) = 0;

  /*
    ThemeStyleChanged безӦ
    @nThemeIndex ǰʽ
  */
  DEFINE_UIEVENT(ThemeStyleChanged, (HcInt32 nThemeIndex)) = 0;

};

class CGcadUiEvents : public CGcadUiEvent
{
private:
  CGcadUiEvents();
  virtual ~CGcadUiEvents();

public:
  /*
    getCurThemeIndex ȡǰ 
    ֵ:  50000+
  */
  HcInt32 getCurThemeIndex();
  /*
    getIconSrc ȡǰԴ
    ֵ: Դ*/
  HINSTANCE getIconSrcInstance(const em_UITYPE& emType);

public:
  /*
    addReactor ӷӦ
    @pReactor ҪӵбķӦ
  */
  virtual void addReactor(CGcadUiReactor* pReactor);
  /*
    removeReactor ƳӦ
    @pReactor ҪбƳķӦ
  */
  virtual void removeReactor(CGcadUiReactor* pReactor);

  /*
    ThemeStyleChanged безӦ
    @nThemeIndex ǰʽ
  */
  DEFINE_UIEVENT(ThemeStyleChanged, (HcInt32 nThemeIndex));

private:
  void initData();
  HINSTANCE loadSrcInstance(const em_UITYPE& emType);
  GcString getSrcName(const em_UITYPE& emType);

public:
  /*
    GcadUiEventInstance ȡUIӦΨһʵ
    ֵ: UIӦΨһʵ
  */
  static CGcadUiEvent* GcadUiEventInstance();
  /*
    releaseUiEvent ͷUIӦΨһʵ
  */
  static void releaseUiEvent();
protected:
  GcArray<GcRxGcadUiReactorPtr> m_arrUiReactor;   //Ӧ
  OdMutex                       m_Mutex;          //ٽ
  HcInt32                       m_nCurThemeIndex; //ǰ
  MAPTHEME2UISRC                m_mapThemeSrc;    //ӦԴ

protected:
  static CGcadUiEvents* m_pGcadEvent;             //UIӦΨһʵ
};

GCUI_DLL_DECL CGcadUiEvent* gcrxUiEvent();       //ȡUIӦʵ

#define FIRE_UIEVENT(method)\
{  CGcadUiEvent* pEvt = gcrxUiEvent();\
  if (NULL != pEvt){pEvt->fire##method;}}

#endif//_UI_REACTOR_H_